<?php
/**
 * Add License Validation
 *
 * @copyright   Copyright (c) 2017, Jeffrey Carandang
 * @since       1.0
*/

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) exit;

if( !function_exists( 'widgetopts_sliding_settings_license_form' ) ):
    function widgetopts_sliding_settings_license_form( $formdata = array() ){
        $item_shortname = 'widgetopts_' . preg_replace( '/[^a-zA-Z0-9_\s]/', '', str_replace( ' ', '_', strtolower( SLIDING_WIDGETOPTS_PLUGIN_NAME ) ) );
		$license_data 	= get_option( $item_shortname . '_license_active' );
        ?>
        <tr>
            <td colspan="2">
                <?php
                    if ( ( defined( 'WIDGETOPTS_PLUGIN_NAME' ) && 'Extended Widget Options' == WIDGETOPTS_PLUGIN_NAME ) ) {
                        echo '<br />';
                    }
                ?>
                <p><strong><?php _e( 'Sliding Widget Options Add-on', 'widget-options' );?></strong></p><br />
                <input type="text" class="widefat widgetopts-license-key" id="widgetopts-license-sliding" placeholder="<?php _e( 'Add License Key', 'widget-options' );?>" name="widgetopts_license_settings[sliding]" value="<?php echo ( is_array( $formdata ) && isset( $formdata['sliding'] ) ) ? $formdata['sliding'] : ''; ?>" />
            </td>
        </tr>
        <tr class="widgetopts-even widgetopts-license-sliding-response">
            <td scope="row" class="td-left">
                <?php if( !empty( $license_data ) && is_object( $license_data ) && isset( $license_data->license ) && $license_data->license == 'valid' ){
                    _e( 'Valid until ' . date( 'M d, Y', strtotime( $license_data->expires ) ), 'widget-options' );
                }else if( !empty( $license_data ) && is_object( $license_data ) && isset( $license_data->license ) && $license_data->license == 'invalid' ){
                    _e( 'Invalid License Data', 'widget-options' );
                } ?>
            </td>
            <td class="td-right">
                <?php if( !empty( $license_data ) && is_object( $license_data ) && isset( $license_data->license ) && $license_data->license == 'valid' ){ ?>
                    <button class="button button-secondary widgetopts-license_deactivate" id="widgetopts-license-btn-sliding" data-target="widgetopts-license-sliding" data-shortname="<?php echo $item_shortname;?>"><?php _e( 'Deactivate', 'widget-options' ); ?></button>
                <?php } ?>
            </td>
        </tr>
        <?php
    }
    add_action( 'widgetopts_settings_license_form', 'widgetopts_sliding_settings_license_form' );
endif;

if( !function_exists( 'widgetopts_sliding_settings_license_activation' ) ){
    function widgetopts_sliding_settings_license_activation( $postdata = array() ){
        global $widgetopts_sliding_license;

        $optiondata = get_option( 'widgetopts_license_keys' );
		$postdata 	= widgetopts_sanitize_array( $_POST['widgetopts_license_settings'] );

		if( is_array( $postdata ) && !empty( $postdata ) && isset( $postdata['sliding'] ) ){
			$item_shortname = 'widgetopts_' . preg_replace( '/[^a-zA-Z0-9_\s]/', '', str_replace( ' ', '_', strtolower( SLIDING_WIDGETOPTS_PLUGIN_NAME ) ) );
			$details 		= get_option( $item_shortname . '_license_active' );

			if ( is_object( $details ) && 'valid' === $details->license ) {
				//reset if already valid
				$postdata['sliding'] = $optiondata['sliding'];
			}else{
				$widgetopts_sliding_license->activate_license( $postdata['sliding'], sanitize_text_field( $_POST['widgetopts_license_nonce_field'] ) );
				update_option( $item_shortname . '_license_key', $postdata['sliding'] );
			}
		}
    }
    add_action( 'widgetopts_settings_license_activation', 'widgetopts_sliding_settings_license_activation' );
}

?>
