<?php
/**
 * Add Custom Metabox on Menu Admin Page
 * @since   1.0
*/
// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

if( !function_exists( 'widgetopts_menu_nav_widget_metabox' ) ):
	function widgetopts_menu_nav_widget_metabox( $settings ) {
        $custom_param = array( 0 => 'This param will be passed to my_render_menu_metabox' );
			add_meta_box(
	            'widgetopts_on_menu',
				__( 'Widgets on Menu', 'widget-options-menu' ),
				'widgetopts_menu_nav_widget_metabox_content',
				'nav-menus', // important !!!
				'side', // important, only side seems to work!!!
				'low',
				$custom_param
	        );
	}
    add_action( 'admin_head-nav-menus.php', 'widgetopts_menu_nav_widget_metabox' );
endif;

//register metabox contents
if( !function_exists( 'widgetopts_menu_nav_widget_metabox_content' ) ){
	function widgetopts_menu_nav_widget_metabox_content( $object, $args ){
		$widgets = get_option('sidebars_widgets');

		if( isset( $widgets['widgetopts-menu-widgets'] ) && !empty( $widgets['widgetopts-menu-widgets'] ) ){
			global $nav_menu_selected_id, $wp_registered_widgets;
			// Create an array of objects that imitate Post objects
			$menu_items = array();
			$count = 1;
			foreach ( $widgets['widgetopts-menu-widgets'] as $menu_item ) {
				$widgetnumber = $wp_registered_widgets[ $menu_item ][ 'params' ][0][ 'number' ];
				if( isset( $wp_registered_widgets[ $menu_item ] ) && isset( $wp_registered_widgets[ $menu_item ][ 'callback' ] )  && isset( $wp_registered_widgets[ $menu_item ][ 'callback' ][0] ) ){
					$widget = ( isset( $wp_registered_widgets[ $menu_item ][ 'callback' ] ) ) ? $wp_registered_widgets[ $menu_item ][ 'callback' ][0]->get_settings() : array();
					$menu_items[] = (object) array(
						'ID' 				=> $count,
						'db_id' 			=> 0,
						'menu_item_parent' 	=> 0,
						'object_id' 		=> $count,
						'post_parent' 		=> 0,
						'type' 				=> 'widgetopts-menu-widget-item',
						'object' 			=> 'widgetopts-widget-on-menu',
						'type_label' 		=> __( 'Widgets on Menu', 'widget-options-menu' ),
						'title' 			=> ( isset( $widget[ $widgetnumber ][ 'title' ] ) && !empty( $widget[ $widgetnumber ][ 'title' ] ) ) ? $widget[ $widgetnumber ][ 'title' ] : $menu_item,
						'url' 				=> $menu_item,
						'target' 			=> $menu_item,
						'attr_title' 		=> $menu_item,
						'description' 		=> $menu_item,
						'classes' 			=> array(),
						'xfn' 				=> $menu_item,
					);
				}
				$count++;
			}


			$db_fields = false;
			// If your links will be hieararchical, adjust the $db_fields array bellow
			if ( false ) {
				$db_fields = array( 'parent' => 'parent', 'id' => 'post_parent' );
			}
			$walker = new Walker_Nav_Menu_Checklist( $db_fields );
			$removed_args = array(
				'action',
				'customlink-tab',
				'edit-menu-item',
				'menu-item',
				'page-tab',
				'_wpnonce',
			); ?>
			<div id="my-plugin-div">
				<div id="tabs-panel-my-plugin-all" class="tabs-panel tabs-panel-active">
					<ul id="my-plugin-checklist-pop" class="categorychecklist form-no-clear" >
						<?php echo walk_nav_menu_tree( array_map( 'wp_setup_nav_menu_item', $menu_items ), 0, (object) array( 'walker' => $walker ) ); ?>
					</ul>
				</div>

				<p class="button-controls">
					<span class="list-controls">
						<a href="<?php
							echo esc_url(add_query_arg(
								array(
									'my-plugin-all' => 'all',
									'selectall' => 1,
								),
								remove_query_arg( $removed_args )
							));
						?>#my-menu-test-metabox" class="select-all"><?php _e( 'Select All' ); ?></a>
					</span>

					<span class="add-to-menu">
						<input type="submit"<?php wp_nav_menu_disabled_check( $nav_menu_selected_id ); ?> class="button-secondary submit-add-to-menu right" value="<?php esc_attr_e( 'Add to Menu' ); ?>" name="add-my-plugin-menu-item" id="submit-my-plugin-div" />
						<span class="spinner"></span>
					</span>
				</p>
			</div>
			<?php

		}else{
			//if no widgets was assigned yet
			_e( 'No widgets was assigned on <strong>Widgets on Menu</strong> sidebar widget, ', 'widget-options-menu' );
			echo '<a href="'. esc_url( admin_url( 'widgets.php' ) ) .'">'. __( 'click here to asign one.', 'widget-options-menu' ) .'</a>';
		}
	}
}

?>
