<?php
/**
 * Handles Menu Saving
 * @since   1.0
*/
// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

//add class to parent
if( !function_exists( 'widgetopts_menu_wp_update_nav_menu' ) ):
	function widgetopts_menu_wp_update_nav_menu( $menu_id ){
		$menu_items = wp_get_nav_menu_items( $menu_id, array( 'post_parent' => 0 ) );
		foreach ( $menu_items as $menu ) {
			if( isset( $menu->menu_item_parent ) && '0' == $menu->menu_item_parent ){
				$has_child_widget = widgetopts_menu_check_parent( $menu->ID  );
				if( $has_child_widget ){
					$classes = get_post_meta( $menu->ID , '_menu_item_classes' );
					// echo $menu->ID; die();
					$classes = maybe_serialize( $classes );
					if( !is_array( $classes ) ){
						$classes = array();
					}
					$classes[] = 'widgetopts-menu-widget-parent';

					update_post_meta( $menu->ID , '_menu_item_classes', $classes );
				}
			}
		}
	}
	add_action( 'wp_update_nav_menu', 'widgetopts_menu_wp_update_nav_menu', 10, 4 );
endif;

/**
 * Check if menu has widget children
 *
 * @param $parentId
 * @return boolean
 */
if( !function_exists( 'widgetopts_menu_check_parent' ) ):
	function widgetopts_menu_check_parent( $parentId ){
		$args = array(
			'post_type' 	=> 'nav_menu_item',
			'meta_key' 		=> '_menu_item_menu_item_parent',
			'meta_value' 	=> $parentId,
			'order' 		=> 'ASC',
			'orderby' 		=> 'menu_order',
		);
	    $tmpItems = get_posts( $args );
		if( $tmpItems ){
			foreach ( $tmpItems as $tmpItem ) {
				$type = get_post_meta( $tmpItem->ID, '_menu_item_type', true );
				if( $type == 'widgetopts-menu-widget-item' ){
					return true;
				}
			}
		}
		wp_reset_query();
		wp_reset_postdata();

		return false;
	}
endif;

?>
