<?php
/**
 * Add License Validation
 *
 * @copyright   Copyright (c) 2017, Jeffrey Carandang
 * @since       1.0
*/

// Exit if accessed directly
if ( ! defined( 'ABSPATH' ) ) exit;

if( !function_exists( 'widgetopts_menu_settings_license_form' ) ):
    function widgetopts_menu_settings_license_form( $formdata = array() ){
        $item_shortname = 'widgetopts_' . preg_replace( '/[^a-zA-Z0-9_\s]/', '', str_replace( ' ', '_', strtolower( WIDGETOPTS_MENU_PLUGIN_NAME ) ) );
		$license_data 	= get_option( $item_shortname . '_license_active' );
        ?>
        <tr>
            <td colspan="2"><br />
                <p><strong><?php _e( 'Widgets on Menu Addon', 'widget-options-menu' );?></strong></p><br />
                <input type="text" class="widefat widgetopts-license-key" id="widgetopts-license-menu" placeholder="<?php _e( 'Add License Key', 'widget-options' );?>" name="widgetopts_license_settings[menu]" value="<?php echo ( is_array( $formdata ) && isset( $formdata['menu'] ) ) ? $formdata['menu'] : ''; ?>" />
            </td>
        </tr>
        <tr class="widgetopts-even widgetopts-license-menu-response">
            <td scope="row" class="td-left">
                <?php if( !empty( $license_data ) && is_object( $license_data ) && isset( $license_data->license ) && $license_data->license == 'valid' ){
                    _e( 'Valid until ' . date( 'M d, Y', strtotime( $license_data->expires ) ), 'widget-options' );
                } ?>
            </td>
            <td class="td-right">
                <?php if( !empty( $license_data ) && is_object( $license_data ) && isset( $license_data->license ) && $license_data->license == 'valid' ){ ?>
                    <button class="button button-secondary widgetopts-license_deactivate" id="widgetopts-license-btn-menu" data-target="widgetopts-license-menu"><?php _e( 'Deactivate', 'widget-options' ); ?></button>
                <?php } ?>
            </td>
        </tr>
        <?php
    }
    add_action( 'widgetopts_settings_license_form', 'widgetopts_menu_settings_license_form' );
endif;

if( !function_exists( 'widgetopts_menu_settings_license_activation' ) ){
    function widgetopts_menu_settings_license_activation( $postdata = array() ){
        global $widgetopts_menu_license;

        $optiondata = get_option( 'widgetopts_license_keys' );
		$postdata 	= widgetopts_sanitize_array( $_POST['widgetopts_license_settings'] );

		if( is_array( $postdata ) && !empty( $postdata ) && isset( $postdata['menu'] ) ){
			$item_shortname = 'widgetopts_' . preg_replace( '/[^a-zA-Z0-9_\s]/', '', str_replace( ' ', '_', strtolower( WIDGETOPTS_MENU_PLUGIN_NAME ) ) );
			$details 		= get_option( $item_shortname . '_license_active' );

			if ( is_object( $details ) && 'valid' === $details->license ) {
				//reset if already valid
				$postdata['menu'] = $optiondata['menu'];
			}else{
				$widgetopts_menu_license->activate_license( $postdata['menu'], sanitize_text_field( $_POST['widgetopts_license_nonce_field'] ) );
				update_option( $item_shortname . '_license_key', $postdata['menu'] );
			}
		}
    }
    add_action( 'widgetopts_settings_license_activation', 'widgetopts_menu_settings_license_activation' );
}

?>
