<?php
/**
 * Handles Menu Frontend Display
 * @since   1.0
*/
// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

//change menu ID
if( !function_exists( 'widgetopts_nav_menu_item_id' ) ):
	function widgetopts_nav_menu_item_id( $menu_id, $item, $args, $depth  ){
		if( isset( $item->type ) && $item->type == 'widgetopts-menu-widget-item' ){
			$menu_id = $item->xfn;
		}

		return $menu_id;
	}

	add_action( 'nav_menu_item_id', 'widgetopts_nav_menu_item_id', 10, 4 );
endif;

//handles menu classes
if( !function_exists( 'widgetopts_nav_menu_css_class' ) ):
	function widgetopts_nav_menu_css_class( $classes, $item  ){
		if( in_array( 'widgetopts-menu-widget-parent', $classes ) ){
			// if( isset( $menu['table'] ) && '1' == $menu['table'] ){
			// 	$classes[] = 'widgetopts-menu-widget-table';
			// }
		}else if( isset( $item->type ) && $item->type == 'widgetopts-menu-widget-item' ){
			global $widget_options, $wp_registered_widgets, $wp_registered_sidebars;

			$callback = ( isset( $wp_registered_widgets[ $item->xfn ]['callback'] ) ) ? $wp_registered_widgets[ $item->xfn ]['callback'] : '';
			if ( !empty( $callback ) &&  is_callable( $callback ) ) {
				// get our sidebar/widget area
				$sidebar = array_merge(

						// our sidebar
						$wp_registered_sidebars[ 'widgetopts-menu-widgets' ],

						// we merge our current widget into it
						array(
							'widget_id' 	=> $item->xfn,
							'widget_name' 	=> $wp_registered_widgets[ $item->xfn ][ 'name' ]
						)
					);

				// set up the widget parameters
				$params = array_merge(
						array($sidebar),
						(array) $wp_registered_widgets[ $item->xfn ]['params']
				);
				ob_start();
				call_user_func_array( $callback, $params );
				$cb = ob_get_clean();
				// echo $cb;
				if ( ( strpos( $cb, 'class=' ) === false ) ) {
					 $classes[] = 'widgetopts_must_hide';
					 return $classes;
				}
			}

			if( isset( $wp_registered_widgets[ $item->xfn ] ) && isset( $wp_registered_widgets[ $item->xfn ]['callback'] ) && isset( $wp_registered_widgets[ $item->xfn ]['params'] ) ){
				$option_name 	= $wp_registered_widgets[ $item->xfn ]['callback'][0]->option_name;
				$key 			= $wp_registered_widgets[ $item->xfn ]['params'][0]['number'];
				$widget_data 	= get_option( $option_name );
				$output 		= $widget_data[ $key ];
				$widgetops 		= $output['extended_widget_opts-' . $item->xfn ];
				$get_classes 	= widgetopts_classes_generator( $widgetops, $widget_options, $widget_options['settings'], false );
				$classes[] 		= 'widget';
				$classes 		= array_merge( $classes, $get_classes );
			}
		}

		return $classes;
	}

	add_action( 'nav_menu_css_class', 'widgetopts_nav_menu_css_class', 10, 4 );
endif;

if( !function_exists( 'widgetopts_walker_nav_menu_start_el' ) ):
	function widgetopts_walker_nav_menu_start_el( $item_output, $item, $depth, $args ){

		if( isset( $item->type ) && $item->type == 'widgetopts-menu-widget-item' ){
			global $wp_registered_widgets;
			if( isset( $wp_registered_widgets[ $item->xfn ] ) && isset( $wp_registered_widgets[ $item->xfn ]['callback'] ) ){
				$option_name 	= $wp_registered_widgets[ $item->xfn ]['callback'][0]->option_name;
				$item_output = do_shortcode('[do_widget id="'. $item->xfn .'" on_menu="true" container=""]');
				$item_output = '<div class="'. apply_filters( 'widgetops_on_menu_inner_class', 'widget_menu_inner', $item ) .'">'. preg_replace( "/(^<div[^>]*>|<\/div>$)/i", "", $item_output ) . '</div>';
			}

		}

		return $item_output;
	}
	add_action( 'walker_nav_menu_start_el', 'widgetopts_walker_nav_menu_start_el', 10, 4 );
endif;

?>
