<?php
/**
 * Echo Styles on Footer instead of external files
 *
 * @copyright   Copyright (c) 2017, Jeffrey Carandang
 * @since       1.0
 */

 // Exit if accessed directly
 if ( ! defined( 'ABSPATH' ) ) exit;

 if( !function_exists( 'widgetopt_menu_footer_scripts' ) ):
     function widgetopt_menu_footer_scripts(){
          global $widget_options;
          /*
          * Check for transient. If none, then execute Query
          */
          if ( false === ( $styles = get_transient( 'widgetopts_widgets_menu_styles' ) ) ) {

          	  $menu 	 = ( isset( $widget_options['settings']['menu'] ) ) ? $widget_options['settings']['menu'] : array();

                 $styles = '<style type="text/css">';

               		$styles .= '.widgetopts_must_hide{ display: none !important; }';
               		$styles .= '.menu-item-object-widgetopts-widget-on-menu .widget{ width: 100% !important; }';
               		$styles .= '.widgetopts-menu-widget-parent .sub-menu{ width: 100%; ';
               			if( isset( $menu['hidden'] ) && '1' == $menu['hidden'] ){
               				$styles .= 'display: none;';
               			}
               		$styles .= '}';
               		if( isset( $menu['show_on_hover'] ) && '1' == $menu['show_on_hover'] ){
               			$styles .= '.widgetopts-menu-widget-parent:hover .sub-menu{ display: block; }';
               		}
               		$styles .= '.widgetopts-menu-widget-parent .sub-menu .sub-menu{ display: none; }';
               		$styles .= '.widgetopts-menu-widget-parent .sub-menu ul{ left: auto; position: relative; display: block; width: auto; background: transparent; box-shadow: none; }';
               		$styles .= '.widgetopts-menu-widget-parent .sub-menu:before, .widgetopts-menu-widget-parent .sub-menu:after{ display: none !important;}';
               		// $styles .= '.widgetopts-menu-widget-parent .sub-menu:after{
               		// 	visibility: hidden; display: block; font-size: 0; content: " "; clear: both; height: 0;
               		// }';
               		if( isset( $menu['table'] ) && '1' == $menu['table'] ){
               			$styles .= '.widgetopts-menu-widget-parent .sub-menu .menu-item{ display: table-cell; float: none !important; vertical-align: top; position: relative; }';
               		}

               		$styles .= '.widgetopts-menu-widget-parent .sub-menu .menu-item:not(.menu-item-object-widgetopts-widget-on-menu){ clear:both; display: table-row; }';
                         $styles .= '.widgetopts-menu-widget-parent .sub-menu .menu-item .menu-item{ display: block; }';
                         $styles .= '.widgetopts-menu-widget-parent .sub-menu a{ width: auto; border: 0px; }';

               	if( isset( $menu['static'] ) && '1' == $menu['static'] ){
               		$styles .= '@media screen and (min-width: '. apply_filters( 'widgetopts_on_menu_static', '767px' ) .') {';
               		$styles .= '.widgetopts-menu-widget-parent{ position: static !important; }';
               		$styles .= '.widgetopts-menu-widget-parent > a{ position: relative !important; } }';
               	}

               	if( isset( $menu['left'] ) && '1' == $menu['left'] ){
               		$styles .= '.widgetopts-menu-widget-parent .sub-menu{ left: 0px !important; }';
               		// $styles .= '.widgetopts-menu-widget-parent .sub-menu{ display: block; }';
               	}

               	if(
               		( isset( $menu['padding_top'] ) && $menu['padding_top'] != '' ) ||
               		( isset( $menu['padding_right'] ) && $menu['padding_right'] != '' ) ||
               		( isset( $menu['padding_bottom'] ) && $menu['padding_bottom'] != '' ) ||
               		( isset( $menu['padding_left'] ) && $menu['padding_left'] != '' ) ||
               		( isset( $menu['margin_top'] ) && $menu['margin_top'] != '' ) ||
               		( isset( $menu['margin_bottom'] ) && $menu['margin_bottom'] != '' )
               	){
               			$styles .= '.menu-item-object-widgetopts-widget-on-menu.widget{ box-sizing: border-box; -moz-box-sizing: border-box; -webkit-box-sizing: border-box;';
               				if( isset( $menu['padding_top'] ) && $menu['padding_top'] != '' ){
               					$styles .= 'padding-top: '. $menu['padding_top'] .'px !important;';
               				}
               				if( isset( $menu['padding_right'] ) && $menu['padding_right'] != '' ){
               					$styles .= 'padding-right: '. $menu['padding_right'] .'px !important;';
               				}
               				if( isset( $menu['padding_bottom'] ) && $menu['padding_bottom'] != '' ){
               					$styles .= 'padding-bottom: '. $menu['padding_bottom'] .'px !important;';
               				}
               				if( isset( $menu['padding_left'] ) && $menu['padding_left'] != '' ){
               					$styles .= 'padding-left: '. $menu['padding_left'] .'px !important;';
               				}

               				//margins
               				if( isset( $menu['margin_top'] ) && $menu['margin_top'] != '' ){
               					$styles .= 'margin-top: '. $menu['margin_top'] .'px !important;';
               				}
               				if( isset( $menu['margin_bottom'] ) && $menu['margin_bottom'] != '' ){
               					$styles .= 'margin-bottom: '. $menu['margin_bottom'] .'px !important;';
               				}
               			$styles .= '}';
               	}

               	if( isset( $menu['toRelative'] ) && !empty( $menu['toRelative'] ) ){
               		$styles .= $menu['toRelative'] . '{ position: relative; }';
               	}

               	//media query
               	$styles .= '@media screen and (min-width: 769px) { .widgetopts-menu-widget-table .widget.extendedwopts-col.col-md-12{ display: block; } }';
               	$styles .= '@media screen and (max-width: 768px) and (min-width: 737px) { .widgetopts-menu-widget-table .widget.extendedwopts-col.col-sm-12{ display: block; } }';
               	$styles .= '@media screen and (max-width: 736px) { .widgetopts-menu-widget-table .widget.extendedwopts-col.col-xs-12{ display: block; } }';


                 $styles .= '</style>';

                 echo apply_filters( 'widgetopts_on_menu_styles', $styles );

               // Put the results in a transient. Expire after 4 weeks.
               set_transient( 'widgetopts_widgets_menu_styles', $styles, 4 * WEEK_IN_SECONDS );

          }else{
               echo apply_filters( 'widgetopts_on_menu_styles', $styles );
          }
     }
     add_action( 'wp_footer', 'widgetopt_menu_footer_scripts' );
 endif;

 ?>
